SystemOrganization addCategory: #'Puzzles-Core'!

Matrix subclass: #IrregularGrid
	instanceVariableNames: 'regions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Puzzles-Core'!

!IrregularGrid class methodsFor: 'instance creation' stamp: 'mg 6/27/2014 11:17'!
newFromFile: aFileName

	| file charList grid puzzleSize |
	charList := OrderedCollection new.
	file := MultiByteFileStream fileNamed: aFileName.
	file upToEnd asString substrings
		collect: [:row | row do: [:char | charList add: char]].
	puzzleSize := charList size sqrt.
	file close.
	grid := IrregularGrid new: puzzleSize element: 0.
	grid buildRegionsFrom: charList.

	^ grid! !

!IrregularGrid methodsFor: 'initialize-release' stamp: 'mg 6/27/2014 11:19'!
buildRegionsFrom: aCharacterList

	regions := Matrix new: self rowCount tabulate: [:i :j | aCharacterList at: (j \\ 10 + (i-1*9))].! !

!IrregularGrid methodsFor: 'initialize-release' stamp: 'mg 6/27/2014 11:16'!
initialize

	super initialize.
	regions := Matrix new: 9.! !

!IrregularGrid methodsFor: 'accessing' stamp: 'mg 6/27/2014 11:26'!
regionWithIdentifier: aCharacter

	| region |
	region := OrderedCollection new.
	regions withIndicesDo: [:val :row :col | 
		val = aCharacter ifTrue: [region add: (self at: row at: col)]].
	^ region! !

!IrregularGrid methodsFor: 'accessing' stamp: 'mg 6/27/2014 11:35'!
regions

	^ regions! !
